#include <iostream>
#include <functional>

#include <gtkmm/window.h>
#include <gtkmm/application.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/fixed.h>
#include <gtkmm/image.h>

//#define OLDWEBKITGTK

#ifdef OLDWEBKITGTK
#include <webkit/webkit.h>
#else
#include <webkit2/webkit2.h>
#endif

void updateVisual(Gtk::Widget& handler)
{
    auto screen = handler.get_screen();
    if (screen)
    {
        auto visual = screen->get_rgba_visual();
        if (visual)
        {
            gtk_widget_set_visual(handler.gobj(), visual->gobj());
            gtk_widget_set_app_paintable(handler.gobj(), true);
        }
    }
}

int main(int argc, char** argv)
{
    auto app = Gtk::Application::create(argc, argv, "org.gtkmm.example");
    Gtk::Window window;
    Gtk::Fixed container;
    Gtk::ScrolledWindow webViewWindow;

    Gtk::Image image;
    image.set(Gdk::Pixbuf::create_from_file("/home/stivius/test.png", 1366, 768, false));

    auto webView = reinterpret_cast<WebKitWebView*>(webkit_web_view_new());
    auto webViewWidget = Gtk::manage(Glib::wrap(reinterpret_cast<GtkWidget*>(webView)));
    webViewWindow.add(*webViewWidget);
    updateVisual(webViewWindow);

#ifdef OLDWEBKITGTK
    webkit_web_view_set_transparent(webView, true);
#else
    GdkRGBA transparent;
    gdk_rgba_parse(&transparent, "rgba(0,0,0,0)");
    webkit_web_view_set_background_color(webView, &transparent);
#endif

    webkit_web_view_load_uri(webView, "file:///home/stivius/transparent.html");

    webViewWindow.set_size_request(300, 200);
    container.put(image, 0, 0);
    container.put(webViewWindow, 0, 0);
    window.add(container);
    window.show_all();

    return app->run(window);
}
